Path = require 'path'

Chalk    = require 'chalk'
inquirer = require 'inquirer'

module.exports = ->
  done = @async()
  prompts = []
  prompts.push
    type   : 'input'
    name   : 'module'
    message: 'Module name'
    validate: (str) ->
      if not str
        'Required field'
      else
        true

  prompts.push
    type   : 'input'
    name   : 'description'
    message: 'Description'
    validate: (str) ->
      if not str
        'Required field'
      else
        true

  prompts.push
    type   : 'input'
    name   : 'author'
    message: 'Author'
    store  : true
    validate: (str) ->
      if not str
        'Required field'
      else
        true

  prompts.push
    type   : 'input'
    name   : 'version'
    message: 'Version'
    default: '0.0.0'
    validate: (str) ->
      validVersion = str.match(/^(\d+\.)(\d+\.)(\d+)$/)
      if validVersion
        true
      else
        'Please enter a valid version number ( 0.0.0 )'

  prompts.push
    type:'list'
    name:'project'
    message:'Project'
    choices: [
      "runtime","sdk",new inquirer.Separator(),"runtime-api","sdk-api"
    ]

  @prompt prompts, ((answers) ->
    @LOCALS            = @LOCALS or {}
    @LOCALS            = answers
    @LOCALS.gitName    = @gitName
    @LOCALS.moduleName = "g4-#{@LOCALS.project}-#{@LOCALS.module}"
    @LOCALS.pckName    = "@intelisis/g4-#{@LOCALS.project}-#{@LOCALS.module}"
    @LOCALS.path       = if @LOCALS.project.indexOf('api') > 0 then 'back' else 'front'
    @LOCALS.repo       = "https://github.com/IntelisisG4/#{@LOCALS.path}/#{@LOCALS.gitName}/#{@LOCALS.moduleName}"
    done()
  ).bind(this)


